package com.itbaizhan.controller;

import org.apache.commons.io.FileUtils;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.File;
import java.io.IOException;

@Controller
public class DownLoadController {
    /* 获取所有的文件，并且保存在request中返回 */
    @RequestMapping("/showFiles")
    public String showFiles(HttpServletRequest request, Model model){
        String realPath = request.getSession().getServletContext().getRealPath("/upload");
        /* 获取目录 */
        File dir = new File(realPath);
        /* 获取目录下的所有文件集合 */
        String[] list = dir.list();
        model.addAttribute("files",list);
        return "download1";
    }

    /* 下载文件 */
    @RequestMapping("/fileDown")
    public void fileDown(HttpServletRequest request, HttpServletResponse response,String filename) throws IOException {
        String realPath = request.getSession().getServletContext().getRealPath("/upload");
        File file = new File(realPath,filename);
        /* 设置响应头 */
        response.setHeader("Content-Disposition","attachment;filename="+filename);
        /* 获取字节输出流 */
        ServletOutputStream os = response.getOutputStream();
        os.write(FileUtils.readFileToByteArray(file));
        os.flush();
        os.close();

    }
}
